/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


import java.io.File;
import java.io.FileFilter;

/**
 *
 * @author petr
 */
public class PorovnaniAdresaru {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {


        if (args.length != 2) {
            System.err.println("Program vyžaduje dva argumenty příkazové řádky");
            System.exit(1);
        }

        File d1 = new File(args[0]);
        File d2 = new File(args[1]);

        System.out.printf("Porovnávám adresáře:%n\t'%s'%n\t'%s'%n%n", d1.getAbsoluteFile(), d2.getAbsoluteFile());

        if (!d1.exists() || !d1.isDirectory()) {
            System.err.println("První argument není název adresáře");
            System.exit(1);
        }

        if (!d2.exists() || !d2.isDirectory()) {
            System.err.println("Druhý argument není název adresáře");
            System.exit(1);
        }

        if(!d1.canRead()) {
            System.err.printf("Adresář %s nelze číst%n",d1.getName());
            System.exit(1);
        }
        if(!d2.canRead()) {
            System.err.printf("Adresář %s nelze číst%n",d2.getName());
            System.exit(1);
        }

        try {
            final File[] list1 = d1.listFiles(new FileFilter() {

                public boolean accept(File pathname) {
                    if (pathname.isFile()) {
                        return true;
                    }
                    return false;
                }
            });
            File[] list = d2.listFiles(new FileFilter() {

                public boolean accept(File pathname) {
                    if (!pathname.isFile()) {
                        return false;
                    }
                    for (File f : list1) {
                        if (f.getName().equals(pathname.getName()) &&
                                f.length() == pathname.length()) {
                            return true;
                        }
                    }
                    return false;
                }
            });
            System.out.println("Nalezené schodné soubory:");
            for (File f : list) {
                System.out.println("\t" + f.getName());
            }
        } catch (SecurityException e) {
            System.err.println(e);
            System.exit(1);
        } catch (NullPointerException e) {
            System.err.println("Nepodařilo se načíst adresáře");
            System.exit(1);
        }
    }
}
